/* ***************************************************************** */
/* $(RTDS_HOME)/share/ccg/nucleus/bricks/RTDS_Startup_begin.c begins */
/* PragmaDev RTDS Nucleus integration                                */

/* Pointers to global list of information on processes and semaphores */
RTDS_GlobalProcessInfo * RTDS_globalProcessInfo = NULL;
RTDS_GlobalProcessInfo * RTDS_globalProcessInfoToDelete = NULL;
RTDS_GlobalSemaphoreInfo * RTDS_globalSemaphoreInfo = NULL;

/* Structure of the memory pool of the system */
NU_MEMORY_POOL System_Memory;

RTDS_COVERAGE_DECL
RTDS_CRITICAL_SECTION_DECL

/* **************************************************************** *
 *RTDS_Start
 * **************************************************************** *
 * That is RTDS generated code entry point.
 * This task or function will create all the static processes and
 * semaphores and when everyone is ready will let them go.
 * **************************************************************** *
 * Parameters:
 *      none
 * Returns:
 *      nothing
 * **************************************************************** */
VOID RTDS_Start( UNSIGNED argc, VOID * argv )
    {
    RTDS_GlobalProcessInfo * globalProcessInfoTmp;
    RTDS_GlobalProcessInfo * RTDS_currentContext;
    
    globalProcessInfoTmp = NULL;
    RTDS_currentContext = NULL;
    
    /* Just to check that RTDS_Start has been executed from Application_Initialize */
    if ( argc != RTDS_TASK_OPTIONS_NUMBER && argv != NU_NULL )
        {
        RTDS_SYSTEM_ERROR( RTDS_ERROR_TASK_OPTIONS_NUMBER );
        }
    
    RTDS_COVERAGE_INIT;
    
#ifdef RTDS_SIMULATOR
    /* Set up the message unique id pool */
    RTDS_globalMessageUniqueIdPool = ( unsigned char * )RTDS_MALLOC( RTDS_MESSAGE_UNIQUE_ID_POOL_SIZE );
    {
    int RTDS_i;
    unsigned char * index;
    
    index = RTDS_globalMessageUniqueIdPool;
    for( RTDS_i = 0; RTDS_i < RTDS_MESSAGE_UNIQUE_ID_POOL_SIZE; RTDS_i++ )
        {
        *index = 0x00;
        index++;
        }
    }
#endif
    
#if defined( RTDS_BACK_TRACE_MAX_EVENT_NUM ) && defined( RTDS_SIMULATOR )
    /* Initialize circular buffer to trace in RAM */
    RTDS_TraceInit();
#endif
    
    /* Set up the process context needed to create tasks */
    RTDS_currentContext = ( RTDS_GlobalProcessInfo * )RTDS_MALLOC( sizeof( RTDS_GlobalProcessInfo ) );
    
    RTDS_currentContext->sdlProcessNumber = 0;
    RTDS_currentContext->sdlState = 0;
    RTDS_currentContext->currentMessage = NULL;
    RTDS_currentContext->timerList = NULL;
    RTDS_currentContext->myRtosTaskId = NULL;
    RTDS_currentContext->mySdlInstanceId = NULL;
    RTDS_currentContext->parentSdlInstanceId = NULL;
    RTDS_currentContext->offspringSdlInstanceId = NULL;
#ifdef RTDS_SIMULATOR
    RTDS_currentContext->priority = 0;
#endif
    RTDS_currentContext->processStack = NU_NULL;
    RTDS_currentContext->queueArea = NU_NULL;
    RTDS_currentContext->readSaveQueue = NULL;
    RTDS_currentContext->writeSaveQueue = NULL;
    RTDS_currentContext->next = NULL;
    
    RTDS_CRITICAL_SECTION_INIT;
    /* $(RTDS_HOME)/share/ccg/nucleus/bricks/RTDS_Startup_begin.c ends */
    /* *************************************************************** */
